module Main where

import           Criterion.Main
import qualified Data.ByteString.Lazy as BSL
import           Language.Dhall.Lexer

main :: IO ()
main =
    defaultMain [ env allEnv $ \ ~(big, med) ->
                  bgroup "lexDhall"
                      [ bench "lexer (large)" $ nf lexDhall big
                      , bench "lexer (medium)" $ nf lexDhall med
                      ]
                ]
    where l = BSL.readFile "test/data/big.dhall"
          m = BSL.readFile "test/data/sample.dhall"
          allEnv = (,) <$> l <*> m
